/* CertButton.c generated by valac 0.35.7, the Vala compiler
 * generated from CertButton.vala, do not modify */

/*
* Copyright (c) 2016-2017 elementary LLC (http://launchpad.net/capnet-assist)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gcr/gcr-base.h>
#include <ui/gcr-ui.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define TYPE_CERT_BUTTON (cert_button_get_type ())
#define CERT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CERT_BUTTON, CertButton))
#define CERT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CERT_BUTTON, CertButtonClass))
#define IS_CERT_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CERT_BUTTON))
#define IS_CERT_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CERT_BUTTON))
#define CERT_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CERT_BUTTON, CertButtonClass))

typedef struct _CertButton CertButton;
typedef struct _CertButtonClass CertButtonClass;
typedef struct _CertButtonPrivate CertButtonPrivate;

#define CERT_BUTTON_TYPE_SECURITY (cert_button_security_get_type ())

#define TYPE_CAPTIVE_LOGIN (captive_login_get_type ())
#define CAPTIVE_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CAPTIVE_LOGIN, CaptiveLogin))
#define CAPTIVE_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CAPTIVE_LOGIN, CaptiveLoginClass))
#define IS_CAPTIVE_LOGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CAPTIVE_LOGIN))
#define IS_CAPTIVE_LOGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CAPTIVE_LOGIN))
#define CAPTIVE_LOGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CAPTIVE_LOGIN, CaptiveLoginClass))

typedef struct _CaptiveLogin CaptiveLogin;
typedef struct _CaptiveLoginClass CaptiveLoginClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))

struct _CertButton {
	GtkToggleButton parent_instance;
	CertButtonPrivate * priv;
};

struct _CertButtonClass {
	GtkToggleButtonClass parent_class;
};

typedef enum  {
	CERT_BUTTON_SECURITY_NONE,
	CERT_BUTTON_SECURITY_SECURE,
	CERT_BUTTON_SECURITY_LOADING,
	CERT_BUTTON_SECURITY_MIXED_CONTENT
} CertButtonSecurity;

struct _CertButtonPrivate {
	CertButtonSecurity _security;
	CaptiveLogin* _captive_login_window;
};

struct _Block2Data {
	int _ref_count_;
	CertButton* self;
	GtkPopover* popover;
};


static gpointer cert_button_parent_class = NULL;

GType cert_button_get_type (void) G_GNUC_CONST;
GType cert_button_security_get_type (void) G_GNUC_CONST;
GType captive_login_get_type (void) G_GNUC_CONST;
#define CERT_BUTTON_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CERT_BUTTON, CertButtonPrivate))
enum  {
	CERT_BUTTON_DUMMY_PROPERTY,
	CERT_BUTTON_SECURITY,
	CERT_BUTTON_CAPTIVE_LOGIN_WINDOW
};
CertButton* cert_button_new (CaptiveLogin* captive_login_window);
CertButton* cert_button_construct (GType object_type, CaptiveLogin* captive_login_window);
static void cert_button_on_tls_button_click (CertButton* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
CaptiveLogin* cert_button_get_captive_login_window (CertButton* self);
gboolean captive_login_get_tls_info (CaptiveLogin* self, GTlsCertificate* * certificate, GTlsCertificateFlags* errors);
gchar* captive_login_get_uri (CaptiveLogin* self);
CertButtonSecurity cert_button_get_security (CertButton* self);
static gboolean __lambda7_ (CertButton* self, GdkEventButton* event);
static gboolean ___lambda7__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean __lambda8_ (Block2Data* _data2_, GdkEventButton* event);
static gboolean ___lambda8__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
void cert_button_set_security (CertButton* self, CertButtonSecurity value);
void cert_button_set_captive_login_window (CertButton* self, CaptiveLogin* value);
static GObject * cert_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _cert_button_on_tls_button_click_gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void cert_button_finalize (GObject * obj);
static void _vala_cert_button_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_cert_button_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GType cert_button_security_get_type (void) {
	static volatile gsize cert_button_security_type_id__volatile = 0;
	if (g_once_init_enter (&cert_button_security_type_id__volatile)) {
		static const GEnumValue values[] = {{CERT_BUTTON_SECURITY_NONE, "CERT_BUTTON_SECURITY_NONE", "none"}, {CERT_BUTTON_SECURITY_SECURE, "CERT_BUTTON_SECURITY_SECURE", "secure"}, {CERT_BUTTON_SECURITY_LOADING, "CERT_BUTTON_SECURITY_LOADING", "loading"}, {CERT_BUTTON_SECURITY_MIXED_CONTENT, "CERT_BUTTON_SECURITY_MIXED_CONTENT", "mixed-content"}, {0, NULL, NULL}};
		GType cert_button_security_type_id;
		cert_button_security_type_id = g_enum_register_static ("CertButtonSecurity", values);
		g_once_init_leave (&cert_button_security_type_id__volatile, cert_button_security_type_id);
	}
	return cert_button_security_type_id__volatile;
}


CertButton* cert_button_construct (GType object_type, CaptiveLogin* captive_login_window) {
	CertButton * self = NULL;
	CaptiveLogin* _tmp0_;
#line 76 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_val_if_fail (captive_login_window != NULL, NULL);
#line 77 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp0_ = captive_login_window;
#line 77 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	self = (CertButton*) g_object_new (object_type, "security", CERT_BUTTON_SECURITY_LOADING, "captive-login-window", _tmp0_, NULL);
#line 76 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return self;
#line 153 "CertButton.c"
}


CertButton* cert_button_new (CaptiveLogin* captive_login_window) {
#line 76 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return cert_button_construct (TYPE_CERT_BUTTON, captive_login_window);
#line 160 "CertButton.c"
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return _data2_;
#line 169 "CertButton.c"
}


static void block2_data_unref (void * _userdata_) {
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 178 "CertButton.c"
		CertButton* self;
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		self = _data2_->self;
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (_data2_->popover);
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (self);
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		g_slice_free (Block2Data, _data2_);
#line 188 "CertButton.c"
	}
}


static gpointer _g_object_ref0 (gpointer self) {
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return self ? g_object_ref (self) : NULL;
#line 196 "CertButton.c"
}


static gboolean __lambda7_ (CertButton* self, GdkEventButton* event) {
	gboolean result = FALSE;
#line 151 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 152 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	result = TRUE;
#line 152 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 208 "CertButton.c"
}


static gboolean ___lambda7__gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda7_ ((CertButton*) self, event);
#line 151 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 217 "CertButton.c"
}


static gboolean __lambda8_ (Block2Data* _data2_, GdkEventButton* event) {
	CertButton* self;
	gboolean result = FALSE;
	GtkWidget* child;
	GtkPopover* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* event_widget;
	GdkEventButton* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GtkWidget* _tmp7_;
#line 155 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	self = _data2_->self;
#line 155 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 156 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp0_ = _data2_->popover;
#line 156 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
#line 156 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 156 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	child = _tmp2_;
#line 157 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp3_ = event;
#line 157 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp4_ = gtk_get_event_widget ((GdkEvent*) _tmp3_);
#line 157 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 157 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	event_widget = _tmp5_;
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp7_ = child;
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (_tmp7_ != NULL) {
#line 258 "CertButton.c"
		GdkEventButton* _tmp8_;
		GdkWindow* _tmp9_;
		GtkPopover* _tmp10_;
		GdkWindow* _tmp11_;
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp8_ = event;
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp9_ = _tmp8_->window;
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp10_ = _data2_->popover;
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp11_ = gtk_widget_get_window ((GtkWidget*) _tmp10_);
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp6_ = _tmp9_ == _tmp11_;
#line 273 "CertButton.c"
	} else {
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp6_ = FALSE;
#line 277 "CertButton.c"
	}
#line 159 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (_tmp6_) {
#line 281 "CertButton.c"
		GtkAllocation child_alloc = {0};
		GtkPopover* _tmp12_;
		GtkAllocation _tmp13_ = {0};
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		GdkEventButton* _tmp17_;
		gdouble _tmp18_;
		GtkAllocation _tmp19_;
		gint _tmp20_;
#line 161 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp12_ = _data2_->popover;
#line 161 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_widget_get_allocation ((GtkWidget*) _tmp12_, &_tmp13_);
#line 161 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		child_alloc = _tmp13_;
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp17_ = event;
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp18_ = _tmp17_->x;
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp19_ = child_alloc;
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp20_ = _tmp19_.x;
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp18_ < ((gdouble) _tmp20_)) {
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp16_ = TRUE;
#line 310 "CertButton.c"
		} else {
			GdkEventButton* _tmp21_;
			gdouble _tmp22_;
			GtkAllocation _tmp23_;
			gint _tmp24_;
			GtkAllocation _tmp25_;
			gint _tmp26_;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp21_ = event;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp22_ = _tmp21_->x;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp23_ = child_alloc;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp24_ = _tmp23_.x;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp25_ = child_alloc;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp26_ = _tmp25_.width;
#line 164 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp16_ = _tmp22_ > ((gdouble) (_tmp24_ + _tmp26_));
#line 332 "CertButton.c"
		}
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp16_) {
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp15_ = TRUE;
#line 338 "CertButton.c"
		} else {
			GdkEventButton* _tmp27_;
			gdouble _tmp28_;
			GtkAllocation _tmp29_;
			gint _tmp30_;
#line 165 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp27_ = event;
#line 165 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp28_ = _tmp27_->y;
#line 165 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp29_ = child_alloc;
#line 165 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp30_ = _tmp29_.y;
#line 165 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp15_ = _tmp28_ < ((gdouble) _tmp30_);
#line 354 "CertButton.c"
		}
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp15_) {
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp14_ = TRUE;
#line 360 "CertButton.c"
		} else {
			GdkEventButton* _tmp31_;
			gdouble _tmp32_;
			GtkAllocation _tmp33_;
			gint _tmp34_;
			GtkAllocation _tmp35_;
			gint _tmp36_;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp31_ = event;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp32_ = _tmp31_->y;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp33_ = child_alloc;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp34_ = _tmp33_.y;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp35_ = child_alloc;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp36_ = _tmp35_.height;
#line 166 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp14_ = _tmp32_ > ((gdouble) (_tmp34_ + _tmp36_));
#line 382 "CertButton.c"
		}
#line 163 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp14_) {
#line 386 "CertButton.c"
			GtkPopover* _tmp37_;
#line 167 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp37_ = _data2_->popover;
#line 167 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			gtk_widget_hide ((GtkWidget*) _tmp37_);
#line 168 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
#line 394 "CertButton.c"
		}
	} else {
		gboolean _tmp38_ = FALSE;
		GtkWidget* _tmp39_;
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp39_ = event_widget;
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp39_ != NULL) {
#line 403 "CertButton.c"
			GtkWidget* _tmp40_;
			GtkPopover* _tmp41_;
			gboolean _tmp42_;
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp40_ = event_widget;
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp41_ = _data2_->popover;
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp42_ = gtk_widget_is_ancestor (_tmp40_, (GtkWidget*) _tmp41_);
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp38_ = !_tmp42_;
#line 415 "CertButton.c"
		} else {
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp38_ = FALSE;
#line 419 "CertButton.c"
		}
#line 170 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp38_) {
#line 423 "CertButton.c"
			GtkPopover* _tmp43_;
#line 171 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp43_ = _data2_->popover;
#line 171 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			gtk_widget_hide ((GtkWidget*) _tmp43_);
#line 172 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
#line 431 "CertButton.c"
		}
	}
#line 175 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	result = TRUE;
#line 175 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (event_widget);
#line 175 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (child);
#line 175 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 442 "CertButton.c"
}


static gboolean ___lambda8__gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = __lambda8_ (self, event);
#line 155 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 451 "CertButton.c"
}


static void cert_button_on_tls_button_click (CertButton* self) {
	Block2Data* _data2_;
	GTlsCertificate* cert = NULL;
	GTlsCertificateFlags cert_flags = 0;
	gboolean _tmp0_;
	CaptiveLogin* _tmp1_;
	GTlsCertificate* _tmp2_ = NULL;
	GTlsCertificateFlags _tmp3_ = 0;
	gboolean _tmp4_;
	GtkPopover* _tmp5_;
	GtkPopover* _tmp6_;
	GIcon* button_icon = NULL;
	GtkWidget* _tmp7_;
	GIcon* _tmp8_ = NULL;
	GIcon* _tmp9_;
	GtkImage* icon;
	GIcon* _tmp10_;
	GtkImage* _tmp11_;
	GtkImage* _tmp12_;
	GtkLabel* primary_text;
	CaptiveLogin* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkLabel* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkLabel* _tmp20_;
	GtkLabel* _tmp21_;
	GtkLabel* secondary_text;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GtkLabel* _tmp24_;
	GtkLabel* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	CertButtonSecurity _tmp28_;
	CertButtonSecurity _tmp29_;
	GcrSimpleCertificate* gcr_cert;
	GTlsCertificate* _tmp38_;
	GByteArray* _tmp39_;
	GByteArray* _tmp40_;
	GByteArray* _tmp41_;
	guint8* _tmp42_;
	gint _tmp42__length1;
	GcrSimpleCertificate* _tmp43_;
	GcrSimpleCertificate* _tmp44_;
	GcrCertificateWidget* cert_details;
	GcrSimpleCertificate* _tmp45_;
	GcrCertificateWidget* _tmp46_;
	GtkGrid* grid;
	GtkGrid* _tmp47_;
	GtkGrid* _tmp48_;
	GtkGrid* _tmp49_;
	GtkImage* _tmp50_;
	GtkGrid* _tmp51_;
	GtkLabel* _tmp52_;
	GtkGrid* _tmp53_;
	GtkLabel* _tmp54_;
	GtkGrid* _tmp55_;
	GcrCertificateWidget* _tmp56_;
	GtkPopover* _tmp57_;
	GtkGrid* _tmp58_;
	GtkPopover* _tmp59_;
	GtkPopover* _tmp60_;
	GtkPopover* _tmp61_;
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_if_fail (self != NULL);
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_data2_->_ref_count_ = 1;
#line 88 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_data2_->self = g_object_ref (self);
#line 92 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp0_ = gtk_toggle_button_get_active ((GtkToggleButton*) self);
#line 92 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (!_tmp0_) {
#line 93 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (cert);
#line 93 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		block2_data_unref (_data2_);
#line 93 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_data2_ = NULL;
#line 93 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		return;
#line 541 "CertButton.c"
	}
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp1_ = self->priv->_captive_login_window;
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp4_ = captive_login_get_tls_info (_tmp1_, &_tmp2_, &_tmp3_);
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (cert);
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	cert = _tmp2_;
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	cert_flags = _tmp3_;
#line 96 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (!_tmp4_) {
#line 97 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) self, FALSE);
#line 98 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (cert);
#line 98 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		block2_data_unref (_data2_);
#line 98 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_data2_ = NULL;
#line 98 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		return;
#line 565 "CertButton.c"
	}
#line 101 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp5_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
#line 101 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp5_);
#line 101 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_data2_->popover = _tmp5_;
#line 102 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp6_ = _data2_->popover;
#line 102 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_container_set_border_width ((GtkContainer*) _tmp6_, (guint) 12);
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp7_ = gtk_button_get_image ((GtkButton*) self);
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_image_get_gicon (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_image_get_type (), GtkImage), &_tmp8_, NULL);
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (button_icon);
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 111 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	button_icon = _tmp9_;
#line 116 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp10_ = button_icon;
#line 116 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp11_ = (GtkImage*) gtk_image_new_from_gicon (_tmp10_, GTK_ICON_SIZE_DIALOG);
#line 116 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp11_);
#line 116 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	icon = _tmp11_;
#line 117 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp12_ = icon;
#line 117 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp12_, GTK_ALIGN_START);
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp13_ = self->priv->_captive_login_window;
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp14_ = captive_login_get_uri (_tmp13_);
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp15_ = _tmp14_;
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp16_ = (GtkLabel*) gtk_label_new (_tmp15_);
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp16_);
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp17_ = _tmp16_;
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_free0 (_tmp15_);
#line 119 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	primary_text = _tmp17_;
#line 120 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp18_ = primary_text;
#line 120 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
#line 120 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_style_context_add_class (_tmp19_, "h3");
#line 121 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp20_ = primary_text;
#line 121 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp20_, GTK_ALIGN_START);
#line 122 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp21_ = primary_text;
#line 122 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp21_, 9);
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp22_ = gtk_widget_get_tooltip_text ((GtkWidget*) self);
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp23_ = _tmp22_;
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp24_ = (GtkLabel*) gtk_label_new (_tmp23_);
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp24_);
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp25_ = _tmp24_;
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_free0 (_tmp23_);
#line 124 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	secondary_text = _tmp25_;
#line 125 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp26_ = secondary_text;
#line 125 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp26_, GTK_ALIGN_START);
#line 126 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp27_ = secondary_text;
#line 126 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp27_, 9);
#line 128 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp28_ = cert_button_get_security (self);
#line 128 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp29_ = _tmp28_;
#line 128 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (_tmp29_ == CERT_BUTTON_SECURITY_SECURE) {
#line 657 "CertButton.c"
		GtkImage* _tmp30_;
		GtkStyleContext* _tmp31_;
		GtkLabel* _tmp32_;
		GtkStyleContext* _tmp33_;
#line 129 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp30_ = icon;
#line 129 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp31_ = gtk_widget_get_style_context ((GtkWidget*) _tmp30_);
#line 129 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_style_context_add_class (_tmp31_, "success");
#line 130 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp32_ = secondary_text;
#line 130 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp33_ = gtk_widget_get_style_context ((GtkWidget*) _tmp32_);
#line 130 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_style_context_add_class (_tmp33_, "success");
#line 674 "CertButton.c"
	} else {
		GtkImage* _tmp34_;
		GtkStyleContext* _tmp35_;
		GtkLabel* _tmp36_;
		GtkStyleContext* _tmp37_;
#line 132 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp34_ = icon;
#line 132 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
#line 132 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_style_context_add_class (_tmp35_, "warning");
#line 133 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp36_ = secondary_text;
#line 133 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp37_ = gtk_widget_get_style_context ((GtkWidget*) _tmp36_);
#line 133 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_style_context_add_class (_tmp37_, "warning");
#line 692 "CertButton.c"
	}
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp38_ = cert;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_get (_tmp38_, "certificate", &_tmp39_, NULL);
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp40_ = _tmp39_;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp41_ = _tmp40_;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp42_ = _tmp41_->data;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp42__length1 = (gint) _tmp41_->len;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp43_ = (GcrSimpleCertificate*) gcr_simple_certificate_new (_tmp42_, _tmp42__length1);
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp44_ = _tmp43_;
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_byte_array_unref0 (_tmp41_);
#line 136 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gcr_cert = _tmp44_;
#line 137 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp45_ = gcr_cert;
#line 137 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp46_ = gcr_certificate_widget_new ((GcrCertificate*) _tmp45_);
#line 137 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp46_);
#line 137 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	cert_details = _tmp46_;
#line 139 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp47_ = (GtkGrid*) gtk_grid_new ();
#line 139 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_ref_sink (_tmp47_);
#line 139 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	grid = _tmp47_;
#line 140 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp48_ = grid;
#line 140 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_grid_set_column_spacing (_tmp48_, 3);
#line 141 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp49_ = grid;
#line 141 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp50_ = icon;
#line 141 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, 0, 0, 1, 2);
#line 142 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp51_ = grid;
#line 142 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp52_ = primary_text;
#line 142 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp52_, 1, 0, 1, 1);
#line 143 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp53_ = grid;
#line 143 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp54_ = secondary_text;
#line 143 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_grid_attach (_tmp53_, (GtkWidget*) _tmp54_, 1, 1, 1, 1);
#line 144 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp55_ = grid;
#line 144 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp56_ = cert_details;
#line 144 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_grid_attach (_tmp55_, (GtkWidget*) _tmp56_, 1, 2, 1, 1);
#line 146 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp57_ = _data2_->popover;
#line 146 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp58_ = grid;
#line 146 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp58_);
#line 151 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp59_ = _data2_->popover;
#line 151 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_signal_connect_object ((GtkWidget*) _tmp59_, "button-press-event", (GCallback) ___lambda7__gtk_widget_button_press_event, self, 0);
#line 155 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp60_ = _data2_->popover;
#line 155 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_signal_connect_data ((GtkWidget*) _tmp60_, "button-release-event", (GCallback) ___lambda8__gtk_widget_button_release_event, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 178 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp61_ = _data2_->popover;
#line 178 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp61_);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (grid);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (cert_details);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (gcr_cert);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (secondary_text);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (primary_text);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (icon);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (button_icon);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (cert);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	block2_data_unref (_data2_);
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_data2_ = NULL;
#line 180 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return;
#line 796 "CertButton.c"
}


CertButtonSecurity cert_button_get_security (CertButton* self) {
	CertButtonSecurity result;
	CertButtonSecurity _tmp0_;
#line 33 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp0_ = self->priv->_security;
#line 34 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 811 "CertButton.c"
}


void cert_button_set_security (CertButton* self, CertButtonSecurity value) {
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (cert_button_get_security (self) != value) {
#line 820 "CertButton.c"
		CertButtonSecurity _tmp0_;
		GIcon* icon = NULL;
		gchar* tooltip = NULL;
		CertButtonSecurity _tmp1_;
		GIcon* _tmp22_;
		GtkImage* _tmp23_;
		GtkImage* _tmp24_;
		const gchar* _tmp25_;
		gboolean _tmp26_ = FALSE;
		CertButtonSecurity _tmp27_;
#line 37 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp0_ = value;
#line 37 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		self->priv->_security = _tmp0_;
#line 42 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp1_ = value;
#line 42 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		switch (_tmp1_) {
#line 42 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			case CERT_BUTTON_SECURITY_LOADING:
#line 841 "CertButton.c"
			{
				GThemedIcon* _tmp2_;
				gchar* _tmp3_;
#line 44 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp2_ = (GThemedIcon*) g_themed_icon_new ("content-loading-symbolic");
#line 44 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_g_object_unref0 (icon);
#line 44 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				icon = (GIcon*) _tmp2_;
#line 45 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp3_ = g_strdup (_ ("Loading captive portal."));
#line 45 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_g_free0 (tooltip);
#line 45 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				tooltip = _tmp3_;
#line 46 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				break;
#line 859 "CertButton.c"
			}
#line 42 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			case CERT_BUTTON_SECURITY_NONE:
#line 863 "CertButton.c"
			{
				gchar* _tmp4_;
				gchar* _tmp5_;
				gchar** _tmp6_;
				gchar** _tmp7_;
				gint _tmp7__length1;
				GThemedIcon* _tmp8_;
				gchar* _tmp9_;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp4_ = g_strdup ("channel-insecure-symbolic");
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp5_ = g_strdup ("security-low");
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp6_ = g_new0 (gchar*, 2 + 1);
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp6_[0] = _tmp4_;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp6_[1] = _tmp5_;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp7_ = _tmp6_;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp7__length1 = 2;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp8_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp7_, 2);
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_g_object_unref0 (icon);
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				icon = (GIcon*) _tmp8_;
#line 48 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 49 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp9_ = g_strdup (_ ("The page is served over an unprotected connection."));
#line 49 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_g_free0 (tooltip);
#line 49 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				tooltip = _tmp9_;
#line 50 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				break;
#line 902 "CertButton.c"
			}
#line 42 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			case CERT_BUTTON_SECURITY_SECURE:
#line 906 "CertButton.c"
			{
				gchar* _tmp10_;
				gchar* _tmp11_;
				gchar** _tmp12_;
				gchar** _tmp13_;
				gint _tmp13__length1;
				GThemedIcon* _tmp14_;
				gchar* _tmp15_;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp10_ = g_strdup ("channel-secure-symbolic");
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp11_ = g_strdup ("security-high");
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp12_ = g_new0 (gchar*, 2 + 1);
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp12_[0] = _tmp10_;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp12_[1] = _tmp11_;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp13_ = _tmp12_;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp13__length1 = 2;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp14_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp13_, 2);
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_g_object_unref0 (icon);
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				icon = (GIcon*) _tmp14_;
#line 53 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 54 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp15_ = g_strdup (_ ("The page is served over a protected connection."));
#line 54 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_g_free0 (tooltip);
#line 54 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				tooltip = _tmp15_;
#line 55 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				break;
#line 945 "CertButton.c"
			}
#line 42 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			case CERT_BUTTON_SECURITY_MIXED_CONTENT:
#line 949 "CertButton.c"
			{
				gchar* _tmp16_;
				gchar* _tmp17_;
				gchar** _tmp18_;
				gchar** _tmp19_;
				gint _tmp19__length1;
				GThemedIcon* _tmp20_;
				gchar* _tmp21_;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp16_ = g_strdup ("channel-insecure-symbolic");
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp17_ = g_strdup ("security-low");
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp18_ = g_new0 (gchar*, 2 + 1);
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp18_[0] = _tmp16_;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp18_[1] = _tmp17_;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp19_ = _tmp18_;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp19__length1 = 2;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp20_ = (GThemedIcon*) g_themed_icon_new_from_names (_tmp19_, 2);
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_g_object_unref0 (icon);
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				icon = (GIcon*) _tmp20_;
#line 58 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_tmp21_ = g_strdup (_ ("Some elements of this page are served over an unprotected connection."));
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				_g_free0 (tooltip);
#line 59 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				tooltip = _tmp21_;
#line 60 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				break;
#line 988 "CertButton.c"
			}
			default:
			{
#line 63 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
				g_assert_not_reached ();
#line 994 "CertButton.c"
			}
		}
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp22_ = icon;
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp23_ = (GtkImage*) gtk_image_new_from_gicon (_tmp22_, GTK_ICON_SIZE_BUTTON);
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		g_object_ref_sink (_tmp23_);
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp24_ = _tmp23_;
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_button_set_image ((GtkButton*) self, (GtkWidget*) _tmp24_);
#line 66 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (_tmp24_);
#line 67 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp25_ = tooltip;
#line 67 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) self, _tmp25_);
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp27_ = value;
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		if (_tmp27_ != CERT_BUTTON_SECURITY_NONE) {
#line 1017 "CertButton.c"
			CertButtonSecurity _tmp28_;
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp28_ = value;
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp26_ = _tmp28_ != CERT_BUTTON_SECURITY_LOADING;
#line 1023 "CertButton.c"
		} else {
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
			_tmp26_ = FALSE;
#line 1027 "CertButton.c"
		}
#line 68 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self, _tmp26_);
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_free0 (tooltip);
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (icon);
#line 36 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		g_object_notify ((GObject *) self, "security");
#line 1037 "CertButton.c"
	}
}


CaptiveLogin* cert_button_get_captive_login_window (CertButton* self) {
	CaptiveLogin* result;
	CaptiveLogin* _tmp0_;
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp0_ = self->priv->_captive_login_window;
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	result = _tmp0_;
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return result;
#line 1053 "CertButton.c"
}


void cert_button_set_captive_login_window (CertButton* self, CaptiveLogin* value) {
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_return_if_fail (self != NULL);
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	if (cert_button_get_captive_login_window (self) != value) {
#line 1062 "CertButton.c"
		CaptiveLogin* _tmp0_;
		CaptiveLogin* _tmp1_;
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp0_ = value;
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		_g_object_unref0 (self->priv->_captive_login_window);
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		self->priv->_captive_login_window = _tmp1_;
#line 73 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		g_object_notify ((GObject *) self, "captive-login-window");
#line 1075 "CertButton.c"
	}
}


static void _cert_button_on_tls_button_click_gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 85 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	cert_button_on_tls_button_click ((CertButton*) self);
#line 1083 "CertButton.c"
}


static GObject * cert_button_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	CertButton * self;
	GtkStyleContext* style_context;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
#line 80 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	parent_class = G_OBJECT_CLASS (cert_button_parent_class);
#line 80 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 80 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CERT_BUTTON, CertButton);
#line 81 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 81 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 81 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	style_context = _tmp1_;
#line 82 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp2_ = style_context;
#line 82 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_style_context_add_class (_tmp2_, GTK_STYLE_CLASS_FLAT);
#line 83 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_tmp3_ = style_context;
#line 83 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	gtk_style_context_add_class (_tmp3_, "titlebutton");
#line 85 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_signal_connect_object ((GtkToggleButton*) self, "toggled", (GCallback) _cert_button_on_tls_button_click_gtk_toggle_button_toggled, self, 0);
#line 80 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (style_context);
#line 80 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	return obj;
#line 1122 "CertButton.c"
}


static void cert_button_class_init (CertButtonClass * klass) {
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	cert_button_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_type_class_add_private (klass, sizeof (CertButtonPrivate));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_cert_button_get_property;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_cert_button_set_property;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	G_OBJECT_CLASS (klass)->constructor = cert_button_constructor;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	G_OBJECT_CLASS (klass)->finalize = cert_button_finalize;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERT_BUTTON_SECURITY, g_param_spec_enum ("security", "security", "security", CERT_BUTTON_TYPE_SECURITY, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERT_BUTTON_CAPTIVE_LOGIN_WINDOW, g_param_spec_object ("captive-login-window", "captive-login-window", "captive-login-window", TYPE_CAPTIVE_LOGIN, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1143 "CertButton.c"
}


static void cert_button_instance_init (CertButton * self) {
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	self->priv = CERT_BUTTON_GET_PRIVATE (self);
#line 1150 "CertButton.c"
}


static void cert_button_finalize (GObject * obj) {
	CertButton * self;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CERT_BUTTON, CertButton);
#line 72 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	_g_object_unref0 (self->priv->_captive_login_window);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	G_OBJECT_CLASS (cert_button_parent_class)->finalize (obj);
#line 1162 "CertButton.c"
}


GType cert_button_get_type (void) {
	static volatile gsize cert_button_type_id__volatile = 0;
	if (g_once_init_enter (&cert_button_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CertButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cert_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CertButton), 0, (GInstanceInitFunc) cert_button_instance_init, NULL };
		GType cert_button_type_id;
		cert_button_type_id = g_type_register_static (gtk_toggle_button_get_type (), "CertButton", &g_define_type_info, 0);
		g_once_init_leave (&cert_button_type_id__volatile, cert_button_type_id);
	}
	return cert_button_type_id__volatile;
}


static void _vala_cert_button_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	CertButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CERT_BUTTON, CertButton);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_SECURITY:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		g_value_set_enum (value, cert_button_get_security (self));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_CAPTIVE_LOGIN_WINDOW:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		g_value_set_object (value, cert_button_get_captive_login_window (self));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 1195 "CertButton.c"
		default:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 1201 "CertButton.c"
	}
}


static void _vala_cert_button_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	CertButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CERT_BUTTON, CertButton);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_SECURITY:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		cert_button_set_security (self, g_value_get_enum (value));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		case CERT_BUTTON_CAPTIVE_LOGIN_WINDOW:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		cert_button_set_captive_login_window (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 1223 "CertButton.c"
		default:
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/capnet-assist-0.2.1/src/CertButton.vala"
		break;
#line 1229 "CertButton.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



